#include <Misc.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>

Func _ChangeSkin()
	Local $but_valid, $but_annul, $lab_col_mur, $inpt_col_mur, $but_mur, $lab_ep_mur, $inpt_ep_mur, $ud_mur, $lab_col_cont, $inpt_col_cont, $but_cont, $lab_ep_cont, $inpt_ep_cont, $ud_cont, $lab_fond, $inpt_fond, $but_fond, $lab_cel, $inpt_cel, $ud_cel, $lab_perso, $inpt_perso, $but_perso, $lab_mont, $inpt_mont, $but_mont, $lab_desc, $inpt_desc, $but_desc, $m_skin, $mi_Charge, $mi_Save
	Local $hexCouleurMurTmp, $hexCouleurContourTmp, $hexCouleurFondTmp, $pPersoTmp, $pEscMonteeTmp, $pEscDescenteTmp, $iEpaisseurMurTmp, $iEpaisseurContourTmp, $iTailleCelluleTmp, $hPersoTmp
	
	$hexCouleurMurTmp = $hexCouleurMur
	$hexCouleurContourTmp = $hexCouleurContour
	$hexCouleurFondTmp = $hexCouleurFond
	$pPersoTmp = $pPerso
	$pEscMonteeTmp = $pEscMontee
	$pEscDescenteTmp = $pEscDescente
	$iEpaisseurMurTmp = $iEpaisseurMur
	$iEpaisseurContourTmp = $iEpaisseurContour
	$iTailleCelluleTmp = $iTailleCellule
	$hPersoApercu = $hPerso
	
	$gui_skin = GUICreate("Modifier le design", 500, 400, Default, Default, Default, Default, $gui)
	GUISwitch($gui_skin)
	
	$m_skin = GUICtrlCreateMenu("&Skin")
	$mi_Charge = GUICtrlCreateMenuItem("&Charger", $m_skin)
	$mi_Save = GUICtrlCreateMenuItem("&Enregistrer", $m_skin)
	
	$but_valid = GUICtrlCreateButton("Valider", 100, 340, 100, 30)
	$but_annul = GUICtrlCreateButton("Annuler", 300, 340, 100, 30)
	
	; Murs
	$lab_col_mur = GUICtrlCreateLabel("Couleur des murs :", 20, 23)
	$inpt_col_mur = GUICtrlCreateInput(StringTrimLeft($hexCouleurMur, 4), 155, 20, 50, Default, $ES_READONLY)
	$but_mur = GUICtrlCreateButton("...", 215, 20, 20, 20)
	
	$lab_ep_mur = GUICtrlCreateLabel("Epaisseur des murs (px) :", 20, 53)
	$inpt_ep_mur = GUICtrlCreateInput($iEpaisseurMur, 155, 50, 50, Default, $ES_READONLY)
	$ud_mur = GUICtrlCreateUpdown($inpt_ep_mur)
	GUICtrlSetLimit($ud_mur, 8, 1)
	
	; Contours
	$lab_col_cont = GUICtrlCreateLabel("Couleur du contour :", 20, 83)
	$inpt_col_cont = GUICtrlCreateInput(StringTrimLeft($hexCouleurContour, 4), 155, 80, 50, Default, $ES_READONLY)
	$but_cont = GUICtrlCreateButton("...", 215, 80, 20, 20)
	
	$lab_ep_cont = GUICtrlCreateLabel("Epaisseur du contour (px) :", 20, 113)
	$inpt_ep_cont = GUICtrlCreateInput($iEpaisseurContour, 155, 110, 50, Default, $ES_READONLY)
	$ud_cont = GUICtrlCreateUpdown($inpt_ep_cont)
	GUICtrlSetLimit($ud_cont, 8, 1)
	
	; Fond
	$lab_fond = GUICtrlCreateLabel("Couleur du fond :", 20, 143)
	$inpt_fond = GUICtrlCreateInput(StringTrimLeft($hexCouleurFond, 4), 155, 140, 50, Default, $ES_READONLY)
	$but_fond = GUICtrlCreateButton("...", 215, 140, 20, 20)
	
	; Cellule
	$lab_cel = GUICtrlCreateLabel("Taille d'un cellule (px) :", 20, 173)
	$inpt_cel = GUICtrlCreateInput($iTailleCellule, 155, 170, 50, Default, $ES_READONLY)
	$ud_cel = GUICtrlCreateUpdown($inpt_cel)
	GUICtrlSetLimit($ud_cel, 32, 16)
	
	; Personnage
	$lab_perso = GUICtrlCreateLabel("Image du personnage :", 20, 233)
	$inpt_perso = GUICtrlCreateInput(_NomFicher($pPerso), 155, 230, 100, Default, $ES_READONLY)
	$but_perso = GUICtrlCreateButton("...", 265, 230, 20, 20)
	
	; Monte
	$lab_mont = GUICtrlCreateLabel("Image d'une monte :", 20, 263)
	$inpt_mont = GUICtrlCreateInput(_NomFicher($pEscMontee), 155, 260, 100, Default, $ES_READONLY)
	$but_mont = GUICtrlCreateButton("...", 265, 260, 20, 20)
	
	; Descente
	$lab_desc = GUICtrlCreateLabel("Image d'une descente :", 20, 293)
	$inpt_desc = GUICtrlCreateInput(_NomFicher($pEscDescente), 155, 290, 100, Default, $ES_READONLY)
	$but_desc = GUICtrlCreateButton("...", 265, 290, 20, 20)
	
	GUISetState()
	GUISetState(@SW_DISABLE, $gui)
	_DesactiveRaccourcis()
	$hGraphicWndSkin = _GDIPlus_GraphicsCreateFromHWND($gui_skin)
	
	_CreeImage(200, 200, $hImageApercu, $hGraphicApercu)
	_DessineExemple($hGraphicApercu)
	
	Local $resultat = 0, $iEpaisseurMurOld = $iEpaisseurMur, $iEpaisseurContourOld = $iEpaisseurContour, $iTailleCelluleOld = $iTailleCellule
	While 1
		$msg = GUIGetMsg()
		$iEpaisseurMur = GUICtrlRead($inpt_ep_mur)
		$iEpaisseurContour = GUICtrlRead($inpt_ep_cont)
		$iTailleCellule = GUICtrlRead($inpt_cel)
		
		Select
			Case $msg = $GUI_EVENT_CLOSE Or $msg = $but_annul
				$hexCouleurMur = $hexCouleurMurTmp
				$hexCouleurContour = $hexCouleurContourTmp
				$hexCouleurFond = $hexCouleurFondTmp
				$pPerso = $pPersoTmp
				$pEscMontee = $pEscMonteeTmp
				$pEscDescente = $pEscDescenteTmp
				$iEpaisseurMur = $iEpaisseurMurTmp
				$iEpaisseurContour = $iEpaisseurContourTmp
				$iTailleCellule = $iTailleCelluleTmp
				If $hPerso <> $hPersoApercu Then _GDIPlus_ImageDispose($hPersoApercu)
				ExitLoop
			Case $msg = $but_valid
				If $hPerso <> $hPersoApercu Then _GDIPlus_ImageDispose($hPerso)
				$hPerso = $hPersoApercu
				$resultat = 1
				ExitLoop
				
			Case $msg = $mi_Save
				_EnregistreSkin()
			Case $msg = $mi_Charge
				_ChargeSkin($inpt_col_mur, $inpt_col_cont, $inpt_fond, $inpt_perso, $inpt_mont, $inpt_desc, $inpt_ep_mur, $inpt_ep_cont, $inpt_cel)
				
			Case $iEpaisseurMurOld <> $iEpaisseurMur Or $iEpaisseurContourOld <> $iEpaisseurContour Or $iTailleCelluleOld <> $iTailleCellule
				_DessineExemple($hGraphicApercu)
				$iEpaisseurMurOld = $iEpaisseurMur
				$iEpaisseurContourOld = $iEpaisseurContour
				$iTailleCelluleOld = $iTailleCellule
			Case $msg = $but_mur
				_ChangeCouleur($hexCouleurMur, $inpt_col_mur)
			Case $msg = $but_cont
				_ChangeCouleur($hexCouleurContour, $inpt_col_cont)
			Case $msg = $but_fond
				_ChangeCouleur($hexCouleurFond, $inpt_fond, 1)
			Case $msg = $but_perso
				_ChangeFichier($pPerso, $inpt_perso, 1)
			Case $msg = $but_mont
				_ChangeFichier($pEscMontee, $inpt_mont)
			Case $msg = $but_desc
				_ChangeFichier($pEscDescente, $inpt_desc)
		EndSelect
	WEnd
	
	GUIDelete($gui_skin)
	$gui_skin = ""
	GUISetState(@SW_ENABLE, $gui)
	WinActivate($gui)
	_ActiveRaccourcis()
	Return $resultat
EndFunc   ;==>_ChangeSkin


#Region FICHIER
Func _EnregistreSkin()
	Local $sSkin = InputBox("Enregistrer un skin", "Choisissez un nom pour le skin", "", " M")
	If @error = 1 Then Return
	IniReadSection(@ScriptDir & "\skins.ini", $sSkin)
	If @error <> 1 Then
		If MsgBox(260, "Enregistrer un skin", "Le skin " & $sSkin & " existe dj !" & @CRLF & "Voulez-vous l'craser ?") = 7 Then Return
	EndIf
	
	IniWrite(@ScriptDir & "\skins.ini", $sSkin, "ColFond", "0x" & StringRight($hexCouleurFond, 6))
	IniWrite(@ScriptDir & "\skins.ini", $sSkin, "ColMurs", "0x" & StringRight($hexCouleurMur, 6))
	IniWrite(@ScriptDir & "\skins.ini", $sSkin, "EpMurs", $iEpaisseurMur)
	IniWrite(@ScriptDir & "\skins.ini", $sSkin, "ColContour", "0x" & StringRight($hexCouleurContour, 6))
	IniWrite(@ScriptDir & "\skins.ini", $sSkin, "EpContour", $iEpaisseurContour)
	IniWrite(@ScriptDir & "\skins.ini", $sSkin, "TailleCellule", $iTailleCellule)
	IniWrite(@ScriptDir & "\skins.ini", $sSkin, "Police", "Arial")
	IniWrite(@ScriptDir & "\skins.ini", $sSkin, "ColPolice", "0x00007F")
	IniWrite(@ScriptDir & "\skins.ini", $sSkin, "Perso", $pPerso)
	IniWrite(@ScriptDir & "\skins.ini", $sSkin, "Montee", $pEscMontee)
	IniWrite(@ScriptDir & "\skins.ini", $sSkin, "Descente", $pEscDescente)
EndFunc   ;==>_EnregistreSkin


Func _ChargeSkin($inpt_col_mur, $inpt_col_cont, $inpt_fond, $inpt_perso, $inpt_mont, $inpt_desc, $inpt_ep_mur, $inpt_ep_cont, $inpt_cel)
	Local $sSkin
	$sSkin = _SkinNameDialog()
	If $sSkin = "" Then Return
	
	IniReadSection(@ScriptDir & "\skins.ini", $sSkin)
	If @error = 1 Then
		MsgBox(16, "Erreur", "Le skin " & $sSkin & " n'existe pas !")
		Return
	EndIf
	
	$hexCouleurFond = "0xFF" & StringRight(IniRead(@ScriptDir & "\skins.ini", $sSkin, "ColFond", $hexCouleurFond), 6)
	$hexCouleurMur = "0xFF" & StringRight(IniRead(@ScriptDir & "\skins.ini", $sSkin, "ColMurs", $hexCouleurMur), 6)
	$hexCouleurContour = "0xFF" & StringRight(IniRead(@ScriptDir & "\skins.ini", $sSkin, "ColContour", $hexCouleurContour), 6)
	$iEpaisseurMur = IniRead(@ScriptDir & "\skins.ini", $sSkin, "EpMurs", $iEpaisseurMur)
	$iEpaisseurContour = IniRead(@ScriptDir & "\skins.ini", $sSkin, "EpContour", $iEpaisseurContour)
	$iTailleCellule = IniRead(@ScriptDir & "\skins.ini", $sSkin, "TailleCellule", $iTailleCellule)
	$pPerso = IniRead(@ScriptDir & "\skins.ini", $sSkin, "Perso", $pPerso)
	$pEscMontee = IniRead(@ScriptDir & "\skins.ini", $sSkin, "Montee", $pEscMontee)
	$pEscDescente = IniRead(@ScriptDir & "\skins.ini", $sSkin, "Descente", $pEscDescente)
	
	GUICtrlSetData($inpt_col_mur, StringRight($hexCouleurMur, 6))
	GUICtrlSetData($inpt_col_cont, StringRight($hexCouleurContour, 6))
	GUICtrlSetData($inpt_fond, StringRight($hexCouleurFond, 6))
	GUICtrlSetData($inpt_perso, _NomFicher($pPerso))
	GUICtrlSetData($inpt_mont, _NomFicher($pEscMontee))
	GUICtrlSetData($inpt_desc, _NomFicher($pEscDescente))
	GUICtrlSetData($inpt_ep_mur, $iEpaisseurMur)
	GUICtrlSetData($inpt_ep_cont, $iEpaisseurContour)
	GUICtrlSetData($inpt_cel, $iTailleCellule)
	
	$hPersoApercu = _ChargePersonnage()
	_DessineExemple($hGraphicApercu)
EndFunc   ;==>_ChargeSkin


Func _SkinNameDialog()
	Local $a_skins_names, $s_skins_names, $i
	
	$a_skins_names = IniReadSectionNames(@ScriptDir & "\skins.ini")
	If @error Then
		MsgBox(16, "Erreur", "Il n'y a pas de skin  charger !")
		Return ""
	EndIf
	
	For $i = 1 To $a_skins_names[0]
		$s_skins_names &= $a_skins_names[$i] & "|"
	Next
	$s_skins_names = StringTrimRight($s_skins_names, 1)
	
	Local $gui_skin_dialog, $lab, $combo, $but_valid, $but_annul
	$gui_skin_dialog = GUICreate("Charger un skin", 200, 110, Default, Default, Default, Default, $gui)
	GUISwitch($gui_skin_dialog)
	
	$lab = GUICtrlCreateLabel("Choisissez un skin :", 20, 13)
	$combo = GUICtrlCreateCombo("", 20, 40)
	GUICtrlSetData($combo, $s_skins_names, $a_skins_names[1])
	$but_valid = GUICtrlCreateButton("Valider", 10, 70, 80, 30)
	$but_annul = GUICtrlCreateButton("Annuler", 110, 70, 80, 30)
	
	GUISetState()
	
	Local $msg, $sSkin
	While 1
		$msg = GUIGetMsg()
		
		Select
			Case $msg = $GUI_EVENT_CLOSE Or $msg = $but_annul
				ExitLoop
			Case $msg = $but_valid
				$sSkin = GUICtrlRead($combo)
				ExitLoop
		EndSelect
	WEnd
	
	GUIDelete($gui_skin_dialog)
	Return $sSkin
EndFunc   ;==>_SkinNameDialog
#EndRegion FICHIER


Func _DessineExemple($hGraphicApercu)
	_Attente(1)
	_GDIPlus_GraphicsClear($hGraphicApercu, 0xFFFFFFFF)
	_DessineLabyrinthe($hGraphicApercu)
	_Attente(0)
	_AfficheImage($gui_skin)
EndFunc   ;==>_DessineExemple


Func _ChangeCouleur(ByRef $hexCouleur, $inpt_col, $iChargePerso = 0)
	Local $hexCouleurTmp = _ChooseColor(2, $hexCouleurMur, 2, $gui_skin)
	If $hexCouleurTmp = -1 Then Return
	
	$hexCouleur = "0xFF" & StringRight($hexCouleurTmp, 6)
	GUICtrlSetData($inpt_col, StringRight($hexCouleur, 6))
	If $iChargePerso Then $hPersoApercu = _ChargePersonnage()
	_DessineExemple($hGraphicApercu)
EndFunc   ;==>_ChangeCouleur


Func _ChangeFichier(ByRef $pFichier, $inpt_fichier, $iChargePerso = 0)
	Local $pTmp = FileOpenDialog("Image du personnage", $pFichier, "Images (*.png; *.jpg; *.jpeg; *.gif; *.bmp)")
	If @error Then Return
	
	$pFichier = $pTmp
	GUICtrlSetData($inpt_fichier, _NomFicher($pFichier))
	If $iChargePerso Then $hPersoApercu = _ChargePersonnage()
	_DessineExemple($hGraphicApercu)
EndFunc   ;==>_ChangeFichier


Func _NomFicher($pFichier)
	Local $aFichier = StringSplit($pFichier, "\")
	Return $aFichier[$aFichier[0]]
EndFunc   ;==>_NomFicher